/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package actualTopic;


import candidateTopic.CandidateTopic;
import constants.Constants;
import java.util.HashSet;
import java.util.Set;
import uk.ac.shef.wit.simmetrics.similaritymetrics.AbstractStringMetric;
import uk.ac.shef.wit.simmetrics.similaritymetrics.Levenshtein;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author iti
 */
public class ActualTopic {
    public Set<Set<String> > mandatoryWords;
    public Set<Set<String> > optionalWords;
    public Set<Set<String> > prohibitedWords;
    public static String termClassSeparator="\t";
    public static String termSeparator=";";
    public static String interSetSeparator=" ";
    public static String setSeparatorStart="[";
    public static String setSeparatorEnd="]";
    public static String regSetSeparatorStart="\\[";
    public static String regSetSeparatorEnd="\\]";
    
    public ActualTopic() {
        initialize();
    }
    
    private void initialize(){
        mandatoryWords=new HashSet<Set<String>>();
        optionalWords=new HashSet<Set<String>>();
        prohibitedWords=new HashSet<Set<String>>();
    }
    
    public void loadFromString(String line){
//        line=line.trim();
       
        String[] classesParts=line.split(termClassSeparator);        
        
//        if(classesParts.length!=3){
//            System.out.println("3 classes of terms need to be defined for topic with keywords:");
//            System.out.println(line);
//            return;
//        }
        String[] tmp_mandatory_parts=classesParts[0].split(termSeparator);
        int i,j;
        for(i=0;i<tmp_mandatory_parts.length;i++){
            String tmp_term=tmp_mandatory_parts[i].trim();
            if(tmp_term.startsWith(setSeparatorStart)&&tmp_term.endsWith(setSeparatorEnd)){
                tmp_term=tmp_term.substring(1,tmp_term.length()-1);
//                tmp_term=tmp_term.replace(regSetSeparatorStart,"");
  //              tmp_term=tmp_term.replace(regSetSeparatorEnd, "");
                String[] final_terms=tmp_term.split(interSetSeparator);
                Set<String> tmp_set=new HashSet<String>();
                for(j=0;j<final_terms.length;j++){
                    String tmp_term_final=final_terms[j].trim();
                    if(tmp_term_final.length()>0)
                        tmp_set.add(tmp_term_final);
                    
                }
                mandatoryWords.add(tmp_set);
            }
            else if((!tmp_term.startsWith(setSeparatorStart))&&(!tmp_term.endsWith(setSeparatorEnd))){
                Set<String> tmp_set=new HashSet<String>();
                tmp_set.add(tmp_term.trim());
                mandatoryWords.add(tmp_set);
            }
            else if((!tmp_term.startsWith(setSeparatorStart))&&(tmp_term.endsWith(setSeparatorEnd))){
                System.out.println("Incorrectly formed term set at topic 1:"+tmp_term);
                System.out.println(line);
            }
            else if((tmp_term.startsWith(setSeparatorStart))&&(!tmp_term.endsWith(setSeparatorEnd))){
                System.out.println("Incorrectly formed term set at topic 2:"+tmp_term);
                System.out.println(line);
            }          
        }
        
        if (classesParts.length>=2) {
        String[] tmp_optional_parts=classesParts[1].split(termSeparator);
        for(i=0;i<tmp_optional_parts.length;i++){
            String tmp_term=tmp_optional_parts[i].trim();
            if(tmp_term.startsWith(setSeparatorStart)&&tmp_term.endsWith(setSeparatorEnd)){
                tmp_term=tmp_term.substring(1,tmp_term.length()-1);
//                tmp_term=tmp_term.replaceFirst(setSeparatorStart,"");
//                tmp_term=tmp_term.replace(setSeparatorEnd, "");
                String[] final_terms=tmp_term.split(interSetSeparator);
                Set<String> tmp_set=new HashSet<String>();
                for(j=0;j<final_terms.length;j++){
                    String tmp_term_final=final_terms[j].trim();
                    if(tmp_term_final.length()>0)
                        tmp_set.add(tmp_term_final);
                    
                }
                optionalWords.add(tmp_set);
            }
            if((!tmp_term.startsWith(setSeparatorStart))&&(!tmp_term.endsWith(setSeparatorEnd))){
                Set<String> tmp_set=new HashSet<String>();
                tmp_set.add(tmp_term.trim());
                optionalWords.add(tmp_set);
            }
            if((!tmp_term.startsWith(setSeparatorStart))&&(tmp_term.endsWith(setSeparatorEnd))){
                System.out.println("Incorrectly formed term set at topic:"+tmp_term);
                System.out.println(line);
            }
            if((tmp_term.startsWith(setSeparatorStart))&&(!tmp_term.endsWith(setSeparatorEnd))){
                System.out.println("Incorrectly formed term set at topic:"+tmp_term);
                System.out.println(line);
            }          
        }
        }
        
        if(classesParts.length==3){
        String[] tmp_prohibited_parts=classesParts[2].split(termSeparator);
        for(i=0;i<tmp_prohibited_parts.length;i++){
            String tmp_term=tmp_prohibited_parts[i].trim();
            if(tmp_term.startsWith(setSeparatorStart)&&tmp_term.endsWith(setSeparatorEnd)){
                  tmp_term=tmp_term.substring(1,tmp_term.length()-1);
                //              tmp_term=tmp_term.replaceFirst(setSeparatorStart,"");
  //              tmp_term=tmp_term.replace(setSeparatorEnd, "");
                String[] final_terms=tmp_term.split(interSetSeparator);
                Set<String> tmp_set=new HashSet<String>();
                for(j=0;j<final_terms.length;j++){
                    String tmp_term_final=final_terms[j].trim();
                    if(tmp_term_final.length()>0)
                        tmp_set.add(tmp_term_final);
                    
                }
                prohibitedWords.add(tmp_set);
            }
            if((!tmp_term.startsWith(setSeparatorStart))&&(!tmp_term.endsWith(setSeparatorEnd))){
                Set<String> tmp_set=new HashSet<String>();
                tmp_set.add(tmp_term.trim());
                prohibitedWords.add(tmp_set);
            }
            if((!tmp_term.startsWith(setSeparatorStart))&&(tmp_term.endsWith(setSeparatorEnd))){
                System.out.println("Incorrectly formed term set at topic:"+tmp_term);
                System.out.println(line);
            }
            if((tmp_term.startsWith(setSeparatorStart))&&(!tmp_term.endsWith(setSeparatorEnd))){
                System.out.println("Incorrectly formed term set at topic:"+tmp_term);
                System.out.println(line);
            }          
        }        
        }
        else{
//            Set<String> tmp_set=new HashSet<String>();
  //          prohibitedWords.add(tmp_set);
        }
            
    }
    
    
    public void print(){
        System.out.println("--------------------------------------------------------");
        System.out.println("Mandatory words:");
        System.out.println("----------------");
        for(Set<String> tmp_set:mandatoryWords){
            System.out.print("[ ");
            for(String tmp_word:tmp_set)
                System.out.print(tmp_word+" ");
            System.out.print(" ]");
            
        }
        System.out.println("");

        System.out.println("Optional words:");
        System.out.println("----------------");
        for(Set<String> tmp_set:optionalWords){
            System.out.print("[ ");
            for(String tmp_word:tmp_set)
                System.out.print(tmp_word+" ");
            System.out.print(" ]");            
        }
        System.out.println("");
        
        System.out.println("Prohibited words:");
        System.out.println("----------------");
        for(Set<String> tmp_set:prohibitedWords){
            System.out.print("[ ");
            for(String tmp_word:tmp_set)
                System.out.print(tmp_word+" ");
            System.out.print(" ]");            
        }
        System.out.println("");

    }

    
    public boolean match(CandidateTopic candidate){
        int i;
        int cand_topic_terms=candidate.terms.size();
        AbstractStringMetric metric = new Levenshtein();//QGramsDistance();//JaroWinkler();//Levenshtein();
      
        boolean mandatory_terms_present=true;
        for(Set<String> tmp_set:mandatoryWords){
            boolean mand_match=false;
            for(String mand_word:tmp_set){
                for(String cand_word:candidate.terms){
                    float result = metric.getSimilarity(mand_word, cand_word);
                    if (result >= Constants.LEVENSHTEIN_DISTANCE_THRESHOLD)
//                    if(mand_word.equals(cand_word)) 
                        mand_match=true;
                }
            }
            if(!mand_match)
                mandatory_terms_present=false;
        }

        boolean prohibited_terms_present=false;
        for(Set<String> tmp_set:prohibitedWords){
            boolean proh_match=false;
            for(String proh_word:tmp_set){
                for(String cand_word:candidate.terms){
                    float result = metric.getSimilarity(proh_word, cand_word);
                    if (result >= Constants.LEVENSHTEIN_DISTANCE_THRESHOLD)
//                    if(proh_word.equals(cand_word)) 
                        proh_match=true;
               //         System.out.println("Match between :"+proh_word+" and " +cand_word);
                }
            }
            if(proh_match)
                prohibited_terms_present=true;
        }
        
        
//        if(!mandatory_terms_present) return false;
//        if(mandatory_terms_present&&prohibited_terms_present) return false;
//        if(mandatory_terms_present&&(prohibited_terms_present)) {
        
        if(mandatory_terms_present&&(!prohibited_terms_present)) {
/*            System.out.println("-----------------------");
            System.out.println("There is a match between: ");
            print();
            System.out.println("----and----");
            candidate.print();
  */          

            return true;
        }
        return false;
    }
    
/*    
    public SingleMatchingResult match(CandidateTopic candidate){
        SingleMatchingResult res=new SingleMatchingResult();
        int i;
        int cand_topic_terms=candidate.terms.size();
        res.candidate_topic_terms=cand_topic_terms;
        res.match=false;
        for(Set<String> tmp_set:mandatoryWords){
            boolean mand_match=false;
            for(String mand_word:tmp_set){
                for(String cand_word:candidate.terms){
                    if(mand_word.equals(cand_word)) 
                        mand_match=true;
                }
            }
            if(!mand_match){
                res.correct_terms=mandatoryWords.size();
                res.match=false;
            }
        }
        
        return res;
    }
    
    */
}
