/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package matchingresult;

import java.text.DecimalFormat;

/**
 *
 * @author iti
 */
public class MatchingResult {
    public int n_aggregate;
    public int n_topic_matches;
    public int n_ground_truth_topics;
    public float topic_recall;
    public int n_actual_topic_terms;
    public int n_candidate_topic_terms;
    public int n_terms_matches;
    public double term_precision;
    public double term_recall;
    public static DecimalFormat df = new DecimalFormat("#.###");

    public MatchingResult() {
        n_aggregate=1;
        n_topic_matches=0;
        n_ground_truth_topics=0;
        topic_recall=0;
        n_actual_topic_terms=0;
        n_candidate_topic_terms=0;
        n_terms_matches=0;
        term_precision=0;
        term_recall=0;
    }
    
    
    
    
    public void print(){
/*
        System.out.println("Topic recall :"+topic_recall+" ("+n_topic_matches+"/"+n_ground_truth_topics+")");
        System.out.println("Term precision :"+term_precision+" ("+n_terms_matches+"/"+n_candidate_topic_terms+")");
        System.out.println("Term recall :"+term_recall+" ("+n_terms_matches+"/"+n_actual_topic_terms+")");
*/
        System.out.print(df.format(topic_recall)+" ("+n_topic_matches+"/"+n_ground_truth_topics+")"+"\t");
        System.out.print(df.format(term_precision)+" ("+n_terms_matches+"/"+n_candidate_topic_terms+")"+"\t");
        System.out.println(df.format(term_recall)+" ("+n_terms_matches+"/"+n_actual_topic_terms+")"+"\t");
    }
    
    public void add(MatchingResult other_result){
        n_topic_matches=n_topic_matches+other_result.n_topic_matches;
        n_ground_truth_topics=n_ground_truth_topics+other_result.n_ground_truth_topics;
        topic_recall=((float)n_topic_matches)/((float)n_ground_truth_topics);
        n_actual_topic_terms=n_actual_topic_terms+other_result.n_actual_topic_terms;
        n_candidate_topic_terms=n_candidate_topic_terms+other_result.n_candidate_topic_terms;
        n_terms_matches=n_terms_matches+other_result.n_terms_matches;
        term_precision=((float)n_terms_matches)/((float)n_candidate_topic_terms);
        term_recall=((float)n_terms_matches)/((float)n_actual_topic_terms);        
        n_aggregate++;
    }
    
}
